<template>
  <section class="py-lg-5">
    <b-container>
      <b-row>
        <b-col col lg="9" class="mx-auto">
          <b-form @submit="submitForm">
            <b-card class="mb-4" no-body>
              <b-card-header><h5 class="card-title">Create a new account</h5></b-card-header>
              <b-card-body class="p-3">
                <b-row>
                  <b-col col lg="6">
                    <a href="/auth/login/google" class="btn btn-block btn-social btn-icon-left btn-google-plus"><i class="fab fa-google"></i> Register with Google</a>
                  </b-col>
                  <b-col col lg="6">
                    <a href="/auth/login/facebook" class="btn btn-block btn-social btn-icon-left btn-facebook"><i class="fab fa-facebook-f"></i> Register with Facebook</a>
                  </b-col>
                </b-row>
                <div class="separator"><span>or</span></div>
                <b-form-group label="Username">
                  <b-input-group>
                    <b-input-group-text slot="prepend"><i class="fal fa-user"></i></b-input-group-text>
                    <b-form-input
                            v-model="form.username"
                            v-validate="{ required: true, min:5, uniqueUsername: true }"
                            data-vv-delay="200"
                            :state="validateState('form.username')"
                            name="form.username"
                            tabindex="1"
                    ></b-form-input>
                    <b-form-invalid-feedback>
                      {{ errors.first('form.username') }}
                    </b-form-invalid-feedback>
                  </b-input-group>
                </b-form-group>

                <b-form-group label="Email Address">
                  <b-input-group>
                    <b-input-group-text slot="prepend"><i class="fal fa-envelope"></i></b-input-group-text>
                    <b-form-input
                            v-model="form.email"
                            v-validate="{ required: true, email: true, uniqueEmail: true }"
                            :state="validateState('form.email')"
                            data-vv-delay="200"
                            name="form.email"
                            tabindex="2"
                    ></b-form-input>
                    <b-form-invalid-feedback>
                      {{ errors.first('form.email') }}
                    </b-form-invalid-feedback>
                  </b-input-group>
                </b-form-group>

                <b-row>
                  <b-col cols="6">
                    <b-form-group label="Password">
                      <b-input-group>
                        <b-input-group-prepend>
                          <span class="input-group-text py-0 px-1" v-html="password_identicon"></span>
                        </b-input-group-prepend>
                        <b-form-input
                                v-model="form.password"
                                v-validate="{ required: true, min:8, is_not: form.username, is_not: form.email }"
                                :state="validateState('form.password')"
                                name="form.password"
                                type="password"
                                ref="password"
                                tabindex="3"
                        ></b-form-input>
                        <b-input-group-append>
                          <b-button variant="info" v-b-modal.password-modal><i class="far fa-question-circle"></i></b-button>
                        </b-input-group-append>
                        <b-form-invalid-feedback>
                          {{ errors.first('form.password') }}
                        </b-form-invalid-feedback>
                      </b-input-group>
                    </b-form-group>
                  </b-col>

                  <b-col cols="6">
                    <b-form-group label="Password Confirm">
                      <b-input-group>
                        <b-input-group-prepend>
                          <span class="input-group-text py-0 px-1" v-html="password_confirmation_identicon"></span>
                        </b-input-group-prepend>
                        <b-form-input
                                v-model="form.password_confirmation"
                                v-validate="{ required: true, confirmed: 'password'}"
                                :state="validateState('form.password_confirmation')"
                                name="form.password_confirmation"
                                type="password"
                                tabindex="4"
                        ></b-form-input>

                        <b-form-invalid-feedback>
                          {{ errors.first('form.password_confirmation') }}
                        </b-form-invalid-feedback>
                      </b-input-group>
                    </b-form-group>
                  </b-col>
                </b-row>

                <b-form-group>
                  <h6 class="mb-3" data-toggle="tooltip" title="Hooray!">Terms of Service</h6>
                  <div class="form-box mb-3" style="height: 180px;">
                    <pre>
Terms of service go here.
and here
and here too
and here also
ohh and here too
more TOS
definitely still need more
legalese is my second language
which means you get more!
</pre>
                  </div>
                  <div class="custom-control custom-checkbox">
                    <input type="checkbox" class="custom-control-input" id="terms" v-model="form.terms" required tabindex="5">
                    <label class="custom-control-label" for="terms">Accept terms of service</label>
                  </div>
                </b-form-group>
              </b-card-body>
              <b-card-footer>
                <b-btn variant="primary" @click="submitForm" :disabled="errors.any() || !form.terms" tabindex="6">Create an Account</b-btn>
              </b-card-footer>
            </b-card>
          </b-form>
        </b-col>
      </b-row>
    </b-container>
    <b-modal id="password-modal" size="lg" ok-only title="Password Recommendations">
      <p class="mb-4">We'd recommend choosing a password that is longer, rather than more complicated. If you're having a difficult time coming up with a good password please see the following XKCD comic or this website:
        <a href="https://www.useapassphrase.com/">https://www.useapassphrase.com/</a>
      </p>
      <img src="https://imgs.xkcd.com/comics/password_strength.png">
    </b-modal>
  </section>
</template>

<script>
  import { Validator } from 'vee-validate'
  import '@/validation/rules/unique-email'
  import '@/validation/rules/unique-username'
  import { ProcessRegistration } from '@/api-services/auth.service'
  import jdenticon from 'jdenticon'
  import Swal from 'sweetalert2'

  const dictionary = {
    en: {
      attributes: {
        'form.email'                : 'email address',
        'form.username'             : 'username',
        'form.password'             : 'password',
        'form.password_confirmation': 'password'
      }
    }
  }

  Validator.localize(dictionary)

  export default {
    name    : 'RegistrationFormComponent',
    data () {
      return {
        isBusy: false,
        form  : {
          email                : '',
          username             : '',
          password             : '',
          password_confirmation: '',
          terms                : false
        }
      }
    },
    computed: {
      password_identicon             : function () {
        return jdenticon.toSvg(this.form.password, 32)
      },
      password_confirmation_identicon: function () {
        return jdenticon.toSvg(this.form.password_confirmation, 32)
      }
    },

    methods: {
      validateState (ref) {
        if (this.veeFields[ref] && this.veeFields[ref].validated) {
          return !this.errors.has(ref)
        }
        return null
      },

      submitForm: function () {
        this.isBusy = true
        ProcessRegistration(this.form).then(function (response) {
          if (response.data.success === true) {

          }
        }).catch(function (error) {
          let resp    = error.response
          let message = ''
          if (resp.status === 422) {
            for (let i in resp.data.errors) {
              let error = resp.data.errors[i][0]

              console.log(error)

              message += error + '<br/>'
            }

            Swal.fire({
              type : 'error',
              title: 'Error Processing Registration',
              html : message
            })
          }
        })
      }
    }
  }
</script>

<style scoped>

</style>
